// This file is generated by kconfig_compiler from kmid2.kcfg.
// All changes you do to this file will be lost.
#ifndef SETTINGS_H
#define SETTINGS_H

#include <kconfigskeleton.h>
#include <kdebug.h>

#include <kglobalsettings.h>
class Settings : public KConfigSkeleton
{
  public:
    enum ResetMode { None, GM, GS, XG, Syx };
    enum AudioFluid { fluid_alsa, fluid_pulseaudio, fluid_oss, fluid_jack };
    enum AudioTimidity { timidity_alsa, timidity_pulseaudio, timidity_oss, timidity_jack };

    static Settings *self();
    ~Settings();

    /**
      Set The font used to display the lyrics.
    */
    static
    void setFont( const QFont & v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "font" ) ))
        self()->mFont = v;
    }

    /**
      Get The font used to display the lyrics.
    */
    static
    QFont font()
    {
      return self()->mFont;
    }

    /**
      Set Size of the lyrics font
    */
    static
    void setSize( int v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "size" ) ))
        self()->mSize = v;
    }

    /**
      Get Size of the lyrics font
    */
    static
    int size()
    {
      return self()->mSize;
    }

    /**
      Set Color of the lyrics text, after being played
    */
    static
    void setColor( const QColor & v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "color" ) ))
        self()->mColor = v;
    }

    /**
      Get Color of the lyrics text, after being played
    */
    static
    QColor color()
    {
      return self()->mColor;
    }

    /**
      Set Initial lyrics text encoding
    */
    static
    void setEncoding( const QString & v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "encoding" ) ))
        self()->mEncoding = v;
    }

    /**
      Get Initial lyrics text encoding
    */
    static
    QString encoding()
    {
      return self()->mEncoding;
    }

    /**
      Set MIDI port connection.
    */
    static
    void setOutput_connection( const QString & v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "output_connection" ) ))
        self()->mOutput_connection = v;
    }

    /**
      Get MIDI port connection.
    */
    static
    QString output_connection()
    {
      return self()->mOutput_connection;
    }

    /**
      Set MIDI mapper file.
    */
    static
    void setMidi_mapper( const QString & v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "midi_mapper" ) ))
        self()->mMidi_mapper = v;
    }

    /**
      Get MIDI mapper file.
    */
    static
    QString midi_mapper()
    {
      return self()->mMidi_mapper;
    }

    /**
      Set Start playing right after loading a song.
    */
    static
    void setPlayer_autostart( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "player_autostart" ) ))
        self()->mPlayer_autostart = v;
    }

    /**
      Get Start playing right after loading a song.
    */
    static
    bool player_autostart()
    {
      return self()->mPlayer_autostart;
    }

    /**
      Set Loop the play list.
    */
    static
    void setPlayer_loop( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "player_loop" ) ))
        self()->mPlayer_loop = v;
    }

    /**
      Get Loop the play list.
    */
    static
    bool player_loop()
    {
      return self()->mPlayer_loop;
    }

    /**
      Set Shuffle the play list.
    */
    static
    void setPlaylist_shuffle( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "playlist_shuffle" ) ))
        self()->mPlaylist_shuffle = v;
    }

    /**
      Get Shuffle the play list.
    */
    static
    bool playlist_shuffle()
    {
      return self()->mPlaylist_shuffle;
    }

    /**
      Set MIDI reset message mode.
    */
    static
    void setReset_mode( ResetMode v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "reset_mode" ) ))
        self()->mReset_mode = v;
    }

    /**
      Get MIDI reset message mode.
    */
    static
    ResetMode reset_mode()
    {
      return static_cast<ResetMode>(self()->mReset_mode);
    }

    /**
      Set System Exclusive MIDI file for reset message.
    */
    static
    void setSysex_file( const KUrl & v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "sysex_file" ) ))
        self()->mSysex_file = v;
    }

    /**
      Get System Exclusive MIDI file for reset message.
    */
    static
    KUrl sysex_file()
    {
      return self()->mSysex_file;
    }

    /**
      Set Show advanced MIDI ports.
    */
    static
    void setAdvanced_ports( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "advanced_ports" ) ))
        self()->mAdvanced_ports = v;
    }

    /**
      Get Show advanced MIDI ports.
    */
    static
    bool advanced_ports()
    {
      return self()->mAdvanced_ports;
    }

    /**
      Set Load and save automatically the song settings.
    */
    static
    void setAuto_song_settings( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "auto_song_settings" ) ))
        self()->mAuto_song_settings = v;
    }

    /**
      Get Load and save automatically the song settings.
    */
    static
    bool auto_song_settings()
    {
      return self()->mAuto_song_settings;
    }

    /**
      Set Run FluidSynth at startup
    */
    static
    void setExec_fluid( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "exec_fluid" ) ))
        self()->mExec_fluid = v;
    }

    /**
      Get Run FluidSynth at startup
    */
    static
    bool exec_fluid()
    {
      return self()->mExec_fluid;
    }

    /**
      Set Command
    */
    static
    void setCmd_fluid( const KUrl & v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "cmd_fluid" ) ))
        self()->mCmd_fluid = v;
    }

    /**
      Get Command
    */
    static
    KUrl cmd_fluid()
    {
      return self()->mCmd_fluid;
    }

    /**
      Set Audio Output
    */
    static
    void setAudio_fluid( AudioFluid v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "audio_fluid" ) ))
        self()->mAudio_fluid = v;
    }

    /**
      Get Audio Output
    */
    static
    AudioFluid audio_fluid()
    {
      return static_cast<AudioFluid>(self()->mAudio_fluid);
    }

    /**
      Set Audio Device
    */
    static
    void setAudiodev_fluid( const QString & v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "audiodev_fluid" ) ))
        self()->mAudiodev_fluid = v;
    }

    /**
      Get Audio Device
    */
    static
    QString audiodev_fluid()
    {
      return self()->mAudiodev_fluid;
    }

    /**
      Set Sample Rate
    */
    static
    void setRate_fluid( const QString & v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "rate_fluid" ) ))
        self()->mRate_fluid = v;
    }

    /**
      Get Sample Rate
    */
    static
    QString rate_fluid()
    {
      return self()->mRate_fluid;
    }

    /**
      Set Sound Font
    */
    static
    void setSf2_fluid( const KUrl & v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "sf2_fluid" ) ))
        self()->mSf2_fluid = v;
    }

    /**
      Get Sound Font
    */
    static
    KUrl sf2_fluid()
    {
      return self()->mSf2_fluid;
    }

    /**
      Set Arguments
    */
    static
    void setArgs_fluid( const QString & v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "args_fluid" ) ))
        self()->mArgs_fluid = v;
    }

    /**
      Get Arguments
    */
    static
    QString args_fluid()
    {
      return self()->mArgs_fluid;
    }

    /**
      Set Run TiMidity++ at startup
    */
    static
    void setExec_timidity( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "exec_timidity" ) ))
        self()->mExec_timidity = v;
    }

    /**
      Get Run TiMidity++ at startup
    */
    static
    bool exec_timidity()
    {
      return self()->mExec_timidity;
    }

    /**
      Set Command
    */
    static
    void setCmd_timidity( const KUrl & v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "cmd_timidity" ) ))
        self()->mCmd_timidity = v;
    }

    /**
      Get Command
    */
    static
    KUrl cmd_timidity()
    {
      return self()->mCmd_timidity;
    }

    /**
      Set Audio Output
    */
    static
    void setAudio_timidity( AudioTimidity v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "audio_timidity" ) ))
        self()->mAudio_timidity = v;
    }

    /**
      Get Audio Output
    */
    static
    AudioTimidity audio_timidity()
    {
      return static_cast<AudioTimidity>(self()->mAudio_timidity);
    }

    /**
      Set Audio Device
    */
    static
    void setAudiodev_timidity( const QString & v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "audiodev_timidity" ) ))
        self()->mAudiodev_timidity = v;
    }

    /**
      Get Audio Device
    */
    static
    QString audiodev_timidity()
    {
      return self()->mAudiodev_timidity;
    }

    /**
      Set Sample Rate
    */
    static
    void setRate_timidity( const QString & v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "rate_timidity" ) ))
        self()->mRate_timidity = v;
    }

    /**
      Get Sample Rate
    */
    static
    QString rate_timidity()
    {
      return self()->mRate_timidity;
    }

    /**
      Set Arguments
    */
    static
    void setArgs_timidity( const QString & v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "args_timidity" ) ))
        self()->mArgs_timidity = v;
    }

    /**
      Get Arguments
    */
    static
    QString args_timidity()
    {
      return self()->mArgs_timidity;
    }

  protected:
    Settings();
    friend class SettingsHelper;


    // Settings
    QFont mFont;
    int mSize;
    QColor mColor;
    QString mEncoding;
    QString mOutput_connection;
    QString mMidi_mapper;
    bool mPlayer_autostart;
    bool mPlayer_loop;
    bool mPlaylist_shuffle;
    int mReset_mode;
    KUrl mSysex_file;
    bool mAdvanced_ports;
    bool mAuto_song_settings;
    bool mExec_fluid;
    KUrl mCmd_fluid;
    int mAudio_fluid;
    QString mAudiodev_fluid;
    QString mRate_fluid;
    KUrl mSf2_fluid;
    QString mArgs_fluid;
    bool mExec_timidity;
    KUrl mCmd_timidity;
    int mAudio_timidity;
    QString mAudiodev_timidity;
    QString mRate_timidity;
    QString mArgs_timidity;

  private:
};

#endif

